	/* Figure 4.61, Aho 2nd ed., pg 296  */
	/* Yacc specification of calculator  */
	/* using ambiguous expression grammar*/
	/* with error recovery.              */

%{
#include <stdio.h>
#include <ctype.h>
#define YYSTYPE double  /* double type for Yacc stack */
%}
%token NUMBER
%left '+' '-'
%left '*' '/'
%right UMINUS
%%

lines	: lines expr '\n'	{ printf("%g\n",$2); /* print result */ }
	| lines '\n'		{ ; /* allow blank lines */ }
	| 			{ ; /* empty string */ }
	| error '\n'	{ yyerror("reenter previous line: "); yyerrok; }
	; 
expr	: expr '+' expr	{ $$ = $1 + $3;}
	| expr '-' expr	{ $$ = $1 - $3;}
	| expr '*' expr	{ $$ = $1 * $3;}
	| expr '/' expr	{ $$ = $1 / $3;}
      	| '(' expr ')'	{ $$ = $2; }
	| '-' expr  %prec UMINUS { $$ = - $2;}
	| NUMBER
	;
%%
#include "lex.yy.c"

